<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>PersistantDataService - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="HttpQuery.html">HttpQuery</a><ul class='methods'><li data-type='method' style='display: none;'><a href="HttpQuery.html#send">send</a></li></ul></li><li><a href="HttpQueryService.html">HttpQueryService</a></li><li><a href="PersistantData.html">PersistantData</a><ul class='methods'><li data-type='method' style='display: none;'><a href="PersistantData.html#loadJSON">loadJSON</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#saveJSON">saveJSON</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#list">list</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#getNewID">getNewID</a></li></ul></li><li><a href="PersistantDataService.html">PersistantDataService</a><ul class='methods'><li data-type='method' style='display: none;'><a href="PersistantDataService.html#~getQuery">getQuery</a></li><li data-type='method' style='display: none;'><a href="PersistantDataService.html#~getNewId">getNewId</a></li></ul></li><li><a href="RemanentForm.html">RemanentForm</a><ul class='methods'><li data-type='method' style='display: none;'><a href="RemanentForm.html#load">load</a></li></ul></li><li><a href="ServerEvent.html">ServerEvent</a><ul class='methods'><li data-type='method' style='display: none;'><a href="ServerEvent.html#onEvent">onEvent</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#isPending">isPending</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#addClock">addClock</a></li></ul></li><li><a href="ServerEventService.html">ServerEventService</a><ul class='methods'><li data-type='method' style='display: none;'><a href="ServerEventService.html#~doQuery">doQuery</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#add">add</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#addClock">addClock</a></li></ul></li><li><a href="StopService.html">StopService</a></li><li><a href="UploadService.html">UploadService</a></li><li><a href="WrapperCC.html">WrapperCC</a><ul class='methods'><li data-type='method' style='display: none;'><a href="WrapperCC.html#call">call</a></li></ul></li><li><a href="WrapperCCService.html">WrapperCCService</a></li><li><a href="cookies.html">cookies</a><ul class='methods'><li data-type='method' style='display: none;'><a href="cookies.html#.get">get</a></li><li data-type='method' style='display: none;'><a href="cookies.html#.set">set</a></li></ul></li><li><a href="slugstring.html">slugstring</a><ul class='methods'><li data-type='method' style='display: none;'><a href="slugstring.html#.fill">fill</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#wrap">wrap</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">PersistantDataService</h1>
    

    




<section>

<header>
    
        <h2>
        
            PersistantDataService
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="PersistantDataService"><span class="type-signature"></span>new PersistantDataService<span class="signature">(server, route)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements a persistent data mechanism.</p>
<ul>
<li>
<p>A POST service is attached to the given route.</p>
</li>
<li>
<p>This is the server side of a simple <a href="./PersistantData.html">client</a>/server mechanism for persistent data.</p>
</li>
<li>
<p>The local service is attached to an express web mechanism, using a construct of the form:</p>
</li>
</ul>
<pre class="prettyprint source"><code>// Loads required packages
const express = require(&quot;express&quot;);
const server = express();
const PersistantDataService = require(&quot;./PersistantDataService.js&quot;);

// Defines a minimal persistantData service
new PersistantDataService(server, &quot;/_persitantData/upload&quot;);
server.listen(8080);
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>server</code></td>
            

            <td class="type">
            
                
<span class="param-type">express</span>



            
            </td>

            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The express server mechanism.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>route</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            
                <td class="default">
                
                    <code>/_persitantData/upload</code>
                
                </td>
            

            <td class="description last"><p>The route, both :</p>
<ul>
<li>The URL route to this service and</li>
<li>The local root directory path.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="~getQuery"><span class="type-signature type-signature-inner">(inner) </span>getQuery<span class="signature">(query)</span><span class="type-signature"> &rarr; {string}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the date file management query.
The data file management queries are:</p>
<ul>
<li><code>action=list[&amp;format=json]</code> :
<ul>
<li>Returns the data file base names list, separated <code>\n</code>.</li>
</ul>
</li>
<li><code>action=load&amp;file=data-file-base-name-without-extension[&amp;format=json]&amp;value=default-value</code> :
<ul>
<li>Loads a file with a default-value if the file does not exists.</li>
</ul>
</li>
<li><code>action=save&amp;file=data-file-base-name-without-extension[&amp;format=json]&amp;value=value&amp;backup=true-or-false</code> :
<ul>
<li>Saves a value in a text file, with a git backup possibility.</li>
</ul>
</li>
<li><code>action=unlink&amp;file=data-file-base-name-without-extension</code> :
<ul>
<li>Moves a data in the <em>./trash</em> directory.</li>
</ul>
</li>
<li><code>action=newid&amp;where=true-or-false&amp;when=true-or-false&amp;suffix=suffix-string</code> :
<ul>
<li>Returns new file ID built from : (i) the date in standard format, if when is true, (ii) the machine MAC address, if where is true, (iii) a suffix is not empty.</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>query</code></td>
            

            <td class="type">
            
                
<span class="param-type">map.&lt;string, string></span>



            
            </td>

            

            

            <td class="description last"><p>The HTTP query, as a structured <code>map&lt;string,string&gt;</code> object already parsed.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The query response.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="~getNewId"><span class="type-signature type-signature-inner">(inner) </span>getNewId<span class="signature">(when, where, suffix)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a new unique ID</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>when</code></td>
            

            <td class="type">
            
            </td>

            

            
                <td class="default">
                
                    <code>true</code>
                
                </td>
            

            <td class="description last"><p>If true</p>
<ul>
<li>adds the current date and time in <code>YYYY-MM-DDThh:mm:ss:msec</code> standard format,</li>
<li>otherwise generates a unique integer for the given machine.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>where</code></td>
            

            <td class="type">
            
            </td>

            

            
                <td class="default">
                
                    <code>false</code>
                
                </td>
            

            <td class="description last"><p>If true adds the current machine MAC as localisation.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>suffix</code></td>
            

            <td class="type">
            
            </td>

            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>If defined, adds a suffix to the ID.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The constructed ID.</p>
</div>



    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>